## linglong 1.6.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.11.4)

project(
  linglong
  VERSION 1.5.1
  DESCRIPTION "a container based package manager for deepin"
  HOMEPAGE_URL "https://github.com/linuxdeepin/linglong"
  LANGUAGES CXX)

set(LINGLONG_VERSION
    ""
    CACHE STRING "The version of linglong project.")

if(NOT ("${LINGLONG_VERSION}" STREQUAL ""))
  message(STATUS "Project version has been overridden to ${LINGLONG_VERSION}")
  set(PROJECT_VERSION ${LINGLONG_VERSION})
endif()

set(ENABLE_UAB OFF CACHE BOOL "enable building UAB")
set(ENABLE_LINGLONG_INSTALLER OFF CACHE BOOL "enable linglong installer")

set(LINGLONG_USERNAME
    "deepin-linglong"
    CACHE STRING "The username for linglong package manager")
set(LINGLONG_ROOT
    "/var/lib/linglong"
    CACHE STRING "The location where linglong related program puts their data")
set(LINGLONG_HOST_PATH
    "/run/host"
    CACHE STRING "The location where linglong host path mapping")
set(LINGLONG_DEFAULT_OCI_RUNTIME
    "ll-box"
    CACHE STRING "The oci runtime which linglong use by default")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(PFL)

set(ENABLE_CPM YES)

if(CMAKE_VERSION VERSION_LESS "3.14")
  set(ENABLE_CPM NO)
  message(
    STATUS "cmake version ${CMAKE_VERSION} not compatible with CPM.cmake.")
endif()

if(CPM_LOCAL_PACKAGES_ONLY)
  set(ENABLE_CPM NO)
endif()

if(ENABLE_CPM)
  include(CPM)
  CPMFindPackage(
    NAME docopt
    VERSION 0.6.1 # NOTE: Upstream cmake version doesn't match git tag, we need
                  # https://github.com/docopt/docopt.cpp/pull/102 in v0.6.3, but
                  # cmake version of v0.6.3 is 0.6.1.
    GITHUB_REPOSITORY docopt/docopt.cpp
    GIT_SHALLOW ON
    GIT_TAG v0.6.3
    EXCLUDE_FROM_ALL ON)
  CPMFindPackage(
    NAME tl-expected
    VERSION 1.0.0 # NOTE: Upstream cmake version doesn't match git tag, we need
                  # https://github.com/TartanLlama/expected/pull/62 in v1.1.0,
                  # but cmake version of v1.1.0 is 1.0.0.
    GITHUB_REPOSITORY TartanLlama/expected
    GIT_TAG v1.1.0
    GIT_SHALLOW ON
    OPTIONS "EXPECTED_BUILD_TESTS OFF"
    EXCLUDE_FROM_ALL ON)
  CPMFindPackage(
    NAME yaml-cpp
    VERSION 0.6.2
    GITHUB_REPOSITORY jbeder/yaml-cpp
    GIT_TAG 0.8.0 # NOTE: When use this project with CPM.cmake(FetchContent), we
                  # need https://github.com/jbeder/yaml-cpp/pull/583 in v0.8.0
    EXCLUDE_FROM_ALL ON
    OPTIONS "YAML_CPP_INSTALL ON" "YAML_CPP_BUILD_TESTS OFF")
  CPMFindPackage(
    NAME nlohmann_json
    VERSION 3.5.0
    URL "https://github.com/nlohmann/json/archive/refs/tags/v3.5.0.tar.gz"
    EXCLUDE_FROM_ALL ON
    OPTIONS "JSON_BuildTests OFF")
endif()

set(linglong_EXTERNALS "ytj ytj::ytj" "http/client client")

# NOTE: UOS v20 do not have docopt packaged.
find_package(docopt 0.6.1 QUIET)
if(NOT docopt_FOUND)
  # list(APPEND linglong_EXTERNALS "docopt.cpp docopt.cpp") # we use header only
  add_library(docopt INTERFACE)
  target_compile_definitions(docopt INTERFACE DOCOPT_HEADER_ONLY)
  target_include_directories(docopt INTERFACE ./external/docopt.cpp)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.external)
endif()

# NOTE: UOS v20 do not have tl-expected packaged.
find_package(tl-expected 1.0.0 QUIET)
if(NOT tl-expected_FOUND)
  # list(APPEND linglong_EXTERNALS tl-expected) # tl-expected requires 3.14
  add_library(tl-expected INTERFACE)
  add_library(tl::expected ALIAS tl-expected)
  target_include_directories(tl-expected
                             INTERFACE ./external/tl-expected/include)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.external)
endif()

find_package(nlohmann_json 3.5.0 QUIET)
if(NOT nlohmann_json_FOUND)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.fix)
  find_package(nlohmann_json 3.5.0 REQUIRED)
endif()

function(get_real_target_name output target)
  get_target_property("${output}" "${target}" ALIASED_TARGET)
  if("${output}" STREQUAL "")
    set("${output}" "${target}")
  endif()
  set("${output}"
      ${${output}}
      PARENT_SCOPE)
endfunction()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# NOTE(black_desk): Qt keywords conflict with glib.
add_definitions("-DQT_NO_KEYWORDS")

# NOTE(black_desk): Enable Qt logging with context.
add_definitions("-DQT_MESSAGELOGCONTEXT")

find_package(
  Qt5
  COMPONENTS Core Concurrent DBus Network WebSockets
  REQUIRED)

find_package(PkgConfig REQUIRED)

pkg_search_module(glib2 REQUIRED IMPORTED_TARGET glib-2.0)
pkg_search_module(ostree1 REQUIRED IMPORTED_TARGET ostree-1)
pkg_search_module(systemd REQUIRED IMPORTED_TARGET libsystemd)
pkg_search_module(ELF REQUIRED IMPORTED_TARGET libelf)

set(ytj_ENABLE_TESTING NO)
set(ytj_ENABLE_INSTALL NO)

pfl_init(AUTO)

add_subdirectory(tools/qdbusxml2cpp)

include(GNUInstallDirs)

pfl_add_libraries(
  LIBS
  api
  dbus-api
  utils
  ocppi
  linglong
  APPS
  generators/00-id-mapping
  generators/05-initialize
  generators/20-devices
  generators/25-host-env
  generators/30-user-home
  generators/40-host-ipc
  generators/90-legacy
  ll-box
  ll-builder
  ll-cli
  ll-package-manager
  llpkg
  uab
  ll-session-helper
  ll-store-installer)

add_subdirectory(misc)

=== misc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include(GNUInstallDirs)

function(configure_files)
  foreach(input ${ARGV})
    configure_file(${input} ${input} @ONLY)
  endforeach()
endfunction()

configure_files(
  # find -regex '\.\/\(script\|share\|lib\|libexec\)\/.*' -type f -printf '%P\n' | sort
  libexec/linglong/app-conf-generator
  libexec/linglong/builder/helper/config-check.sh
  libexec/linglong/builder/helper/ldd-check.sh
  libexec/linglong/builder/helper/main-check.sh
  libexec/linglong/fetch-archive-source
  libexec/linglong/fetch-dsc-source
  libexec/linglong/fetch-file-source
  libexec/linglong/fetch-git-source
  libexec/linglong/upgrade-all
  lib/linglong/container/config.d/10-basics.json
  lib/linglong/container/config.d/25-host-rootfs.json
  lib/linglong/container/config.d/25-host-statics.json
  lib/linglong/container/config.json
  lib/linglong/container/README.md
  lib/systemd/system-environment-generators/61-linglong
  lib/systemd/system/org.deepin.linglong.PackageManager.service
  lib/systemd/system-preset/91-linglong.preset
  lib/systemd/user-environment-generators/61-linglong
  lib/systemd/user/linglong-session-helper.service
  lib/systemd/user/linglong-upgrade.service
  lib/systemd/user/linglong-upgrade.timer
  lib/sysusers.d/linglong.conf
  lib/tmpfiles.d/linglong.conf
  script/linglong-repair-tool
  script/linglong.sh
  share/applications/linglong-repair-tool.desktop
  share/applications/linglong-store-installer.desktop
  share/bash-completion/completions/ll-builder
  share/bash-completion/completions/ll-cli
  share/dbus-1/system.d/org.deepin.linglong.PackageManager.conf
  share/dbus-1/system-services/org.deepin.linglong.PackageManager.service
  share/linglong/builder/config-check.sh
  share/linglong/builder/ldd-check.sh
  share/linglong/builder/main-check.sh
  share/linglong/builder/templates/appimage-local.yaml
  share/linglong/builder/templates/appimage-url.yaml
  share/linglong/builder/templates/example.yaml
  share/linglong/config.yaml
  share/mime/packages/deepin-linglong.xml
  share/polkit-1/actions/org.deepin.linglong.PackageManager.policy)

# bash-completion
set(BASH_COMPLETIONS_DIR ${CMAKE_INSTALL_DATADIR}/bash-completion)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/bash-completion/completions
        DESTINATION ${BASH_COMPLETIONS_DIR})

# dbus
set(DBUS_SYSTEM_BUS_DIR ${CMAKE_INSTALL_DATADIR}/dbus-1)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system.d
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system-services
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})

# linglong
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/00-id-mapping-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/00-id-mapping
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/05-initialize-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/05-initialize
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/20-devices-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/20-devices
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/25-host-env-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/25-host-env
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/30-user-home-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/30-user-home
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/40-host-ipc-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/40-host-ipc
     SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/90-legacy-static
     ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d/90-legacy
     SYMBOLIC)
install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong
  USE_SOURCE_PERMISSIONS)

# linglong default configuration
install(FILES ${CMAKE_CURRENT_LIST_DIR}/share/linglong/config.yaml
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong)

# builder templates
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/share/linglong/builder/templates/
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong/builder/templates)

# libexec
install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/
  DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/linglong
  USE_SOURCE_PERMISSIONS)

# systemd
set(SYSTEMD_SYSTEM_PRESET_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-preset)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-preset/
        DESTINATION ${SYSTEMD_SYSTEM_PRESET_PATH})

set(SYSTEMD_SYSTEM_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system
        DESTINATION ${SYSTEMD_SYSTEM_UNIT_PATH})

set(SYSTEMD_USER_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/user
        DESTINATION ${SYSTEMD_USER_UNIT_PATH})

set(SYSTEMD_USER_GENERATOR_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/user-environment-generators)
install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/user-environment-generators/
  DESTINATION ${SYSTEMD_USER_GENERATOR_PATH}
  USE_SOURCE_PERMISSIONS)

set(SYSTEMD_SYSTEM_GENERATOR_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-environment-generators)
install(
  DIRECTORY
    ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-environment-generators/
  DESTINATION ${SYSTEMD_SYSTEM_GENERATOR_PATH}
  USE_SOURCE_PERMISSIONS)

# sysuser

set(SYSTEMD_SYSUSERSDIR ${CMAKE_INSTALL_PREFIX}/lib/sysusers.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/sysusers.d/
        DESTINATION ${SYSTEMD_SYSUSERSDIR})

# tmpfiles
set(SYSTEMD_TMPFILESDIR ${CMAKE_INSTALL_PREFIX}/lib/tmpfiles.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/tmpfiles.d/
        DESTINATION ${SYSTEMD_TMPFILESDIR})

# xdg
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/mime/packages
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mime)

# set linglong XDG_DATA_DIRS environtment
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
        DESTINATION /etc/profile.d)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
  DESTINATION /etc/X11/Xsession.d/
  RENAME 21linglong)

# linglong-repair-tool bin
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/script/linglong-repair-tool
        DESTINATION ${CMAKE_INSTALL_BINDIR})

# linglong-repair-tool desktop
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/share/applications/linglong-repair-tool.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

# linglong-store-installer.desktop
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/share/applications/linglong-store-installer.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(
  FILES ${CMAKE_SOURCE_DIR}/api/schema/v1.json
  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong/api/
  RENAME api.json)

# polkit actions this file only used to skip DBus security check, it will be
# removed later
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/share/polkit-1/actions/org.deepin.linglong.PackageManager.policy
  DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)

=== apps/ll-box/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BOX_BIN_NAME "ll-box")

if(${STATIC_BOX})
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  message(STATUS "build ll-box statically")
  set(BOX_BIN_NAME "ll-box-static")
  add_link_options(-static -static-libgcc -static-libstdc++)
endif()

pkg_search_module(SECCOMP REQUIRED IMPORTED_TARGET libseccomp)

pfl_add_executable(
  SOURCES
  src/container/container.cpp
  src/container/container.h
  src/container/helper.h
  src/container/helper.cpp
  src/container/mount/filesystem_driver.cpp
  src/container/mount/filesystem_driver.h
  src/container/mount/host_mount.cpp
  src/container/mount/host_mount.h
  src/container/seccomp.cpp
  src/container/seccomp.h
  src/main.cpp
  src/util/common.cpp
  src/util/common.h
  src/util/debug/debug.cpp
  src/util/debug/debug.h
  src/util/filesystem.cpp
  src/util/filesystem.h
  src/util/json.h
  src/util/logger.cpp
  src/util/logger.h
  src/util/macro.h
  src/util/message_reader.cpp
  src/util/message_reader.h
  src/util/oci_runtime.h
  src/util/platform.cpp
  src/util/platform.h
  src/util/semaphore.cpp
  src/util/semaphore.h
  src/util/util.h
  OUTPUT_NAME
  ${BOX_BIN_NAME}
  LINK_LIBRARIES
  PUBLIC
  nlohmann_json::nlohmann_json
  linglong::ocppi
  PkgConfig::SECCOMP
  COMPILE_OPTIONS
  PRIVATE
  -DJSON_USE_IMPLICIT_CONVERSIONS=0)

if(${STATIC_BOX})
  target_link_libraries(PkgConfig::SECCOMP
                        INTERFACE ${SECCOMP_STATIC_LIBRARIES})

  include(GNUInstallDirs)
  file(CREATE_LINK ${CMAKE_INSTALL_FULL_BINDIR}/ll-box-static
       ${CMAKE_CURRENT_BINARY_DIR}/ll-box SYMBOLIC)

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ll-box
          DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
endif()

=== apps/ll-cli/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_executable(
  SOURCES
  ./src/main.cpp
  OUTPUT_NAME
  ll-cli
  LINK_LIBRARIES
  PUBLIC
  linglong::linglong)

=== apps/ll-package-manager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_executable(
  SOURCES
  ./src/main.cpp
  OUTPUT_NAME
  ll-package-manager
  LIBEXEC
  linglong
  LINK_LIBRARIES
  PUBLIC
  linglong::linglong)

=== apps/ll-store-installer/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
if (NOT ${ENABLE_LINGLONG_INSTALLER})
    return()
endif()

find_package(Qt5 REQUIRED Widgets)

pfl_add_executable(
  SOURCES
  src/main.cpp
  src/installer-dialog.cpp
  src/installer-dialog.h
  OUTPUT_NAME
  ll-installer
  LINK_LIBRARIES
  PRIVATE
  Qt5::Widgets
  linglong::linglong)

  include(GNUInstallDirs)

=== apps/llpkg/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include(GNUInstallDirs)

install(PROGRAMS llpkg DESTINATION ${CMAKE_INSTALL_BINDIR})

=== libs/api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/api/types/helper.cpp
  src/linglong/api/types/helper.h
  src/linglong/api/types/v1/ApplicationConfiguration.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissionsBind.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissions.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissionsInnerBind.hpp
  src/linglong/api/types/v1/BuilderConfig.hpp
  src/linglong/api/types/v1/BuilderProject.hpp
  src/linglong/api/types/v1/BuilderProjectPackage.hpp
  src/linglong/api/types/v1/BuilderProjectSource.hpp
  src/linglong/api/types/v1/CliContainer.hpp
  src/linglong/api/types/v1/CommonResult.hpp
  src/linglong/api/types/v1/Generators.hpp
  src/linglong/api/types/v1/helper.hpp
  src/linglong/api/types/v1/LayerInfo.hpp
  src/linglong/api/types/v1/LinglongAPIV1.hpp
  src/linglong/api/types/v1/OciConfigurationPatch.hpp
  src/linglong/api/types/v1/PackageInfo.hpp
  src/linglong/api/types/v1/PackageInfoV2.hpp
  src/linglong/api/types/v1/PackageManager1GetRepoInfoResult.hpp
  src/linglong/api/types/v1/PackageManager1GetRepoInfoResultRepoInfo.hpp
  src/linglong/api/types/v1/PackageManager1InstallParameters.hpp
  src/linglong/api/types/v1/PackageManager1ModifyRepoParameters.hpp
  src/linglong/api/types/v1/PackageManager1Package.hpp
  src/linglong/api/types/v1/PackageManager1ResultWithTaskID.hpp
  src/linglong/api/types/v1/PackageManager1SearchParameters.hpp
  src/linglong/api/types/v1/PackageManager1SearchResult.hpp
  src/linglong/api/types/v1/PackageManager1UninstallParameters.hpp
  src/linglong/api/types/v1/PackageManager1UpdateParameters.hpp
  src/linglong/api/types/v1/RepoConfig.hpp
  src/linglong/api/types/v1/Sections.hpp
  src/linglong/api/types/v1/UabLayer.hpp
  src/linglong/api/types/v1/UabMetaInfo.hpp
  src/linglong/api/types/v1/Version.hpp
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  nlohmann_json::nlohmann_json)

=== libs/dbus-api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/api/dbus/v1/dbus_peer.cpp
  src/linglong/api/dbus/v1/dbus_peer.h
  src/linglong/api/dbus/v1/package_manager.cpp
  src/linglong/api/dbus/v1/package_manager.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  Qt5::Core
  Qt5::DBus)

function(linglong_add_dbus_interface target xml basename) # include

  set_source_files_properties(${xml} NO_NAMESPACE ON)

  if(${ARGC} GREATER 3)
    set(include "${ARGV3}")
    if(include)
      set_source_files_properties(${xml} PROPERTIES INCLUDE ${include})
    endif()
  endif()

  set(INTERFACE_SOURCES)
  set(Qt5DBus_QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp)
  qt5_add_dbus_interface(INTERFACE_SOURCES ${xml} ${basename})
  target_sources(${target} PRIVATE ${INTERFACE_SOURCES})
endfunction()

set(real_dbus_api)
get_real_target_name(real_dbus_api linglong::dbus-api)
target_include_directories(${real_dbus_api} PUBLIC ${CMAKE_CURRENT_BINARY_DIR})

linglong_add_dbus_interface(
  ${real_dbus_api}
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.PackageManager1.xml
  src/linglong/api/dbus/v1/gen_org_deepin_linglong_packagemanager1)

linglong_add_dbus_interface(
  ${real_dbus_api}
  ${PROJECT_SOURCE_DIR}/api/dbus/org.freedesktop.DBus.Peer.xml
  src/linglong/api/dbus/v1/gen_org_freedesktop_dbus_peer)

=== libs/linglong/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  src/linglong/builder/builder_releases.qrc
  # find -regex '\./src/.+\.[ch]\(pp\)?\(\.in\)?' -type f -printf '%P\n'| sort
  src/linglong/adaptors/package_manager/package_manager1.cpp
  src/linglong/adaptors/package_manager/package_manager1.h
  src/linglong/builder/config.cpp
  src/linglong/builder/config.h
  src/linglong/builder/file.cpp
  src/linglong/builder/file.h
  src/linglong/builder/linglong_builder.cpp
  src/linglong/builder/linglong_builder.h
  src/linglong/builder/printer.h
  src/linglong/builder/source_fetcher.cpp
  src/linglong/builder/source_fetcher.h
  src/linglong/cli/cli.cpp
  src/linglong/cli/cli.h
  src/linglong/cli/json_printer.cpp
  src/linglong/cli/json_printer.h
  src/linglong/cli/printer.cpp
  src/linglong/cli/printer.h
  src/linglong/package/architecture.cpp
  src/linglong/package/architecture.h
  src/linglong/package/fuzzy_reference.cpp
  src/linglong/package/fuzzy_reference.h
  src/linglong/package/layer_dir.cpp
  src/linglong/package/layer_dir.h
  src/linglong/package/layer_file.cpp
  src/linglong/package/layer_file.h
  src/linglong/package/layer_packager.cpp
  src/linglong/package/layer_packager.h
  src/linglong/package_manager/package_manager.cpp
  src/linglong/package_manager/package_manager.h
  src/linglong/package_manager/task.cpp
  src/linglong/package_manager/task.h
  src/linglong/package/reference.cpp
  src/linglong/package/reference.h
  src/linglong/package/uab_file.cpp
  src/linglong/package/uab_file.h
  src/linglong/package/uab_packager.cpp
  src/linglong/package/uab_packager.h
  src/linglong/package/version.cpp
  src/linglong/package/version.h
  src/linglong/package/version_range.cpp
  src/linglong/package/version_range.h
  src/linglong/repo/client_factory.cpp
  src/linglong/repo/client_factory.h
  src/linglong/repo/config.cpp
  src/linglong/repo/config.h
  src/linglong/repo/ostree_repo.cpp
  src/linglong/repo/ostree_repo.h
  src/linglong/runtime/container_builder.cpp
  src/linglong/runtime/container_builder.h
  src/linglong/runtime/container.cpp
  src/linglong/runtime/container.h
  # FIXME(black_desk): After refactory, all tests are failed to compile as I
  # have no time to fix them now. Let's bring them back later. TESTS ll-tests
  # http-client-tests
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  linglong::dbus-api
  linglong::utils
  linglong::api
  PkgConfig::ostree1
  PkgConfig::systemd
  PkgConfig::ELF
  Qt5::Concurrent
  Qt5::Core
  Qt5::DBus
  Qt5::Network
  Qt5::WebSockets
  QtLinglongRepoClientAPI
  docopt
  ytj::ytj
  tl::expected
  linglong::ocppi
  ${YAML_CPP})

  function(
    linglong_add_dbus_adaptor
    target
    xml
    includes
    parent_class
    basename
    classname)
    get_real_target_name(target ${target})

    set(DBUS_ADAPTOR_SOURCE)

    set(Qt5DBus_QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp)
    qt5_add_dbus_adaptor(DBUS_ADAPTOR_SOURCE ${xml} ${includes} ${parent_class}
                         ${basename} ${classname})
    # FIXME(black_desk): `qt5_add_dbus_adaptor` will use basename as include and
    # this cannot be configured at all. This is just a workaround.
    target_include_directories(${target} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    target_sources(${target} PRIVATE ${DBUS_ADAPTOR_SOURCE})
  endfunction()

  linglong_add_dbus_adaptor(
    linglong::linglong
    ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.PackageManager1.xml
    linglong/package_manager/package_manager.h
    linglong::service::PackageManager
    src/linglong/adaptors/package_manager/gen_org_deepin_linglong_packagemanager1
    OrgDeepinLinglongPackagemanager1Adaptor)

=== libs/utils/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/*.+\.[ch]\(pp\)?\(.in\)?' -type f -printf '%P\n'| sort
  src/linglong/utils/command/env.cpp
  src/linglong/utils/command/env.h
  src/linglong/utils/command/ocppi-helper.cpp
  src/linglong/utils/command/ocppi-helper.h
  src/linglong/utils/configure.cpp
  src/linglong/utils/configure.h.in
  src/linglong/utils/dbus/log.cpp
  src/linglong/utils/dbus/log.h
  src/linglong/utils/dbus/register.cpp
  src/linglong/utils/dbus/register.h
  src/linglong/utils/error/details/error_impl.cpp
  src/linglong/utils/error/details/error_impl.h
  src/linglong/utils/error/error.cpp
  src/linglong/utils/error/error.h
  src/linglong/utils/finally/finally.cpp
  src/linglong/utils/finally/finally.h
  src/linglong/utils/global/initialize.cpp
  src/linglong/utils/global/initialize.h
  src/linglong/utils/packageinfo_handler.cpp
  src/linglong/utils/packageinfo_handler.h
  src/linglong/utils/serialize/json.cpp
  src/linglong/utils/serialize/json.h
  src/linglong/utils/serialize/yaml.cpp
  src/linglong/utils/serialize/yaml.h
  src/linglong/utils/std_helper/qdebug_helper.h
  src/linglong/utils/transaction.cpp
  src/linglong/utils/transaction.h
  src/linglong/utils/xdg/desktop_entry.cpp
  src/linglong/utils/xdg/desktop_entry.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  Qt5::Core
  Qt5::DBus
  PkgConfig::glib2
  tl::expected
  ytj::ytj
  linglong::ocppi
  linglong::api
  Qt5::Core
  Qt5::DBus)

=== tools/qdbusxml2cpp/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(qdbusxml2cpp qdbusxml2cpp.cpp)

target_link_libraries(qdbusxml2cpp PRIVATE Qt5::DBus Qt5::Core Qt5::DBusPrivate)

=== debian/changelog ===
linglong (1.6.0-1) unstable; urgency=medium

  * feat: Check if the app ID conforms to the rules
  * fix: app exists after the installation job canceled
  * fix: automatic updates will break the base env
  * fix: the upgrade service affects system startup time
  * fix: chromium timezone show error

 -- dengbo <dengbo@deepin.org>  Wed, 07 Aug 2024 13:20:49 +0800

linglong (1.5.9-1) unstable; urgency=medium

  * fix: Correct application's systemd service functionality
  * fix: error when pulling source code with git
  * fix: failed to build deb in uos i386 arch

 -- dengbo <dengbo@deepin.org>  Mon, 29 Jul 2024 10:58:54 +0800

linglong (1.5.8-1) unstable; urgency=medium

  * fix: can not install linglong app from store.linglong.dev
  * feat: ll-build appimage convert support export uab or layer
  * feat: Optimize build progress display
  * fix: example build error in uos20 arm arch
  * fix: builder create return error

 -- dengbo <dengbo@deepin.org>  Tue, 09 Jul 2024 16:44:15 +0800

linglong (1.5.7-1) unstable; urgency=medium

  * fix: failed to run app after ll-cli received SIGINT
  * fix: Canceling a task causes the package manager to crash.
  * fix: remove task after installation
  * fix: ll-cli install return error errcode
  * feat: support for installing from uab
  * fix: container env error when environment variables have multiple values
  * fix: ll-builder convert appimage error when use url
  * fix: update bash completion

 -- dengbo <dengbo@deepin.org>  Mon, 01 Jul 2024 15:32:20 +0800

linglong (1.5.6-1) unstable; urgency=medium

  * fix: layer size error when export layer repeatedly
  * fix: missed some env variables when reusing container
  * fix: builder did not exit when the build script failed
  * feat: add option "--layer" for ll-builder to export layer
  * fix: failed to run linglong app in ubuntu 24.04
  * feat: Create dedicated client for HTTP requests
  * feat: does not use temporary repository when pulling
  * feat: ll-builder allows manual linglong.yaml selection
  * fix: builder did not exit when the build script failed

 -- dengbo <dengbo@deepin.org>  Thu, 20 Jun 2024 16:45:51 +0800

linglong (1.5.1-1) unstable; urgency=medium

  * fix: move the reinstall operation to new script

 -- dengbo <dengbo@deepin.org>  Mon, 13 May 2024 11:35:15 +0800

linglong (1.5.0-1) unstable; urgency=medium

  * release after some refactor.

 -- dengbo <dengbo@deepin.org>  Tue, 23 Apr 2024 15:48:14 +0800

linglong (1.4.3-1) unstable; urgency=medium

  * Fix some ll-builder bugs.
  * Bring `enter` back.
  * Update postinst scrips to remove x11 session hook.

 -- Chen Linxuan <me@black-desk.cn>  Thu, 18 Jan 2024 15:32:29 +0800

linglong (1.4.1-1) unstable; urgency=medium

  * Enable dh_installsysuser;
  * Fix a problem caused by new repository location.

 -- Chen Linxuan <me@black-desk.cn>  Fri, 05 Jan 2024 22:51:39 +0800

linglong (1.4.0-1) unstable; urgency=low

  * First release after some refactory.

 -- Chen Linxuan <me@black-desk.cn>  Wed, 03 Jan 2024 15:56:48 +0800

linglong (1.3.5.1-1) unstable; urgency=medium

  * when launching the application for the second time, use the
    exec parameter in the desktop file instead of the last value.

 -- chenhuixing <chenhuixing@uniontech.com>  Thu, 05 Jan 2023 10:20:21 +0800

linglong (1.3.5-1) unstable; urgency=medium

  * ll-cli repo modify add nodbus mode.

 -- huqinghong <huqinghong@uniontech.com>  Tue, 27 Dec 2022 10:15:00 +0800

linglong (1.3.4-1) unstable; urgency=medium

  * 1. fix ll-cli query prompt in the case of a network failure
  * 2. fix ll-cli run with special symbol
  * 3. fix ll-cli support any repo name

 -- huqinghong <huqinghong@uniontech.com>  Wed, 07 Dec 2022 15:50:01 +0800

linglong (1.3.3.23-1) unstable; urgency=medium

  * update version to 1.3.3.23-1 for deepin.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Mon, 05 Dec 2022 11:03:42 +0800

linglong (1.3.3.22-1) unstable; urgency=medium

  * update version to 1.3.3.22-1 for deepin.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Thu, 25 Nov 2022 11:03:42 +0800

linglong (1.3.3.21-1) unstable; urgency=medium

  * update version to 1.3.3.21-1 for deepin.

 -- huqinghong <huqinghong@uniontech.com>  Thu, 24 Nov 2022 11:03:42 +0800

linglong (1.3.3.20-1) unstable; urgency=medium

  * update version to 1.3.3.20-1 for deepin.

 -- chenhuixing <chenhuixing@uniontech.com>  Fri, 18 Nov 2022 18:38:12 +0800

linglong (1.3.3.19-1) unstable; urgency=medium

  * update version to 1.3.3.19-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 11 Nov 2022 10:19:28 +0800

linglong (1.3.3.18-1) unstable; urgency=medium

  * update version to 1.3.3.18-1 for deepin.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Wed, 02 Nov 2022 15:22:13 +0800

linglong (1.3.3.17-1) unstable; urgency=medium

  * update version to 1.3.3.17-1 for deepin.

 -- huqinghong <huqinghong@uniontech.com>  Wed, 02 Nov 2022 15:22:13 +0800

linglong (1.3.3.16-1) unstable; urgency=medium

  * update version to 1.3.3.16-1 for deepin.

 -- Chen Linxuan <chenlinxuan@uniontech.com>  Thu, 27 Oct 2022 14:55:00 +0800

linglong (1.3.3.14-1) unstable; urgency=medium

  * update version to 1.3.3.14-1 for deepin.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Thu, 08 Sep 2022 15:55:17 +0800

linglong (1.3.3.8-1) unstable; urgency=medium

  * update version to 1.3.3.8-1 for deepin.

 -- huqinghong <huqinghong@uniontech.com>  Thu, 08 Sep 2022 20:35:17 +0800

linglong (1.3.3.7-1) unstable; urgency=medium

  * update version to 1.3.3.7-1 for deepin.

 -- chenhuixing <chenhuixing@uniontech.com>  Tue, 06 Sep 2022 10:01:10 +0800

linglong (1.3.3.6-1) unstable; urgency=medium

  * update version to 1.3.3.6-1 for deepin.

 -- chenhuixing <chenhuixing@uniontech.com>  Tue, 09 Aug 2022 14:20:18 +0800

linglong (1.3.3.5-1) unstable; urgency=medium

  * update version to 1.3.3.5-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Mon, 01 Aug 2022 20:47:34 +0800

linglong (1.3.3.4-1) unstable; urgency=medium



=== debian/control ===
Source: linglong
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: cmake,
               debhelper-compat (= 12),
               erofsfuse,
               libdeflate-dev,
               libdocopt-dev (>= 0.6.2-2.1) | hello,
               libelf-dev,
               libexpected-dev (>= 1.0.0~dfsg-2~bpo10+1) | hello,
               libfuse-dev,
               libglib2.0-dev,
               libgmock-dev,
               libgtest-dev,
               liblz4-dev,
               liblzma-dev,
               libostree-dev,
               libpcre2-dev,
               libqt5websockets5-dev,
               libseccomp-dev,
               libselinux1-dev,
               libssl-dev,
               libsystemd-dev,
               libyaml-cpp-dev (>= 0.6.2),
               libzstd-dev,
               nlohmann-json3-dev (>= 3.5.0),
               pkg-config,
               qt5-qmake,
               qtbase5-dev,
               qtbase5-private-dev,
               systemd,
               zlib1g-dev
Standards-Version: 4.1.3
Homepage: http://www.deepin.org

Package: linglong-bin
Architecture: any
Depends: desktop-file-utils,
         erofsfuse,
         libglib2.0-bin,
         linglong-box | crun,
         ostree,
         shared-mime-info,
         linglong-installer,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: linglong-dbus-proxy
Conflicts: linglong-dbus-proxy
Description: Linglong package manager.
 Linglong package management command line tool.

Package: linglong-builder
Architecture: any
Depends: erofs-utils,
         erofsfuse,
         git,
         libelf1,
         linglong-bin,
         linglong-box | crun,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: devscripts, linglong-loader
Description: Linglong application building tools.
 ll-builder is a tool that makes it easy to build applications and dependencies.

Package: linglong-box
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Deepin sandbox with OCI standard.
 Deepin sandbox...

Package: linglong-installer
Architecture: any
Depends: linglong-bin, ${misc:Depends}, ${shlibs:Depends}
Description: Linglong online store application installation tool.
 Linglong apps installation tool for deepin linglong web store(https://store.linglong.dev/).

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

OS=$(shell awk '/^NAME=/' /etc/os-release | sed 's/NAME=//' | sed 's/\"//g' | tr '[:upper:]' '[:lower:]')
ARCH=$(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)
VERSION=$(shell awk '/VERSION=/' /etc/os-release | sed 's/VERSION=//' | sed 's/\"//g' | sed 's/[.]0/./')
ENABLE_UAB_SUPPORT=FALSE

ifeq ($(OS) $(VERSION), deepin 23)
	ENABLE_UAB_SUPPORT=TRUE
else ifeq ($(OS) $(VERSION), uos 20)
	ENABLE_UAB_SUPPORT=TRUE
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	dh_install -p linglong-bin debian/sysctl.d/linglong.conf usr/lib/sysctl.d/

EXTRA_OPTION = -DCPM_LOCAL_PACKAGES_ONLY=ON -DLINGLONG_VERSION=$(DEB_VERSION_UPSTREAM) -DENABLE_LINGLONG_INSTALLER=ON

ifeq ($(ENABLE_UAB_SUPPORT), TRUE)

	EXTRA_OPTION += -DENABLE_UAB=ON -DSTATIC_BOX=ON

override_dh_auto_install:
	dh_auto_install

	install -d debian/linglong-builder/usr/lib/$(ARCH)/linglong/builder/uab
	dh_install -p linglong-builder usr/lib/$(ARCH)/linglong/builder/uab/ usr/lib/$(ARCH)/linglong/builder/
	dh_install -p linglong-box usr/bin/ll-box-static usr/bin
endif

override_dh_auto_configure:
	dh_auto_configure --  ${EXTRA_OPTION}  ${DH_AUTO_ARGS}

# https://sources.debian.org/src/amavisd-new/1:2.13.0-3/debian/rules/?hl=10#L10
execute_after_dh_installinit:
	dh_installsysusers # this is needed until dh compat 14
